diff -Naur a/src/3rdparty/chromium/third_party/webrtc/audio/channel_send_frame_transformer_delegate.cc b/src/3rdparty/chromium/third_party/webrtc/audio/channel_send_frame_transformer_delegate.cc
--- a/src/3rdparty/chromium/third_party/webrtc/audio/channel_send_frame_transformer_delegate.cc	2021-08-24 12:54:05.000000000 +0100
+++ b/src/3rdparty/chromium/third_party/webrtc/audio/channel_send_frame_transformer_delegate.cc	2021-11-20 03:40:27.218660881 +0000
@@ -15,16 +15,16 @@
 namespace webrtc {
 namespace {
 
-class TransformableAudioFrame : public TransformableFrameInterface {
+class TransformableOutgoingAudioFrame : public TransformableFrameInterface {
  public:
-  TransformableAudioFrame(AudioFrameType frame_type,
-                          uint8_t payload_type,
-                          uint32_t rtp_timestamp,
-                          uint32_t rtp_start_timestamp,
-                          const uint8_t* payload_data,
-                          size_t payload_size,
-                          int64_t absolute_capture_timestamp_ms,
-                          uint32_t ssrc)
+  TransformableOutgoingAudioFrame(AudioFrameType frame_type,
+                                  uint8_t payload_type,
+                                  uint32_t rtp_timestamp,
+                                  uint32_t rtp_start_timestamp,
+                                  const uint8_t* payload_data,
+                                  size_t payload_size,
+                                  int64_t absolute_capture_timestamp_ms,
+                                  uint32_t ssrc)
       : frame_type_(frame_type),
         payload_type_(payload_type),
         rtp_timestamp_(rtp_timestamp),
@@ -32,7 +32,7 @@
         payload_(payload_data, payload_size),
         absolute_capture_timestamp_ms_(absolute_capture_timestamp_ms),
         ssrc_(ssrc) {}
-  ~TransformableAudioFrame() override = default;
+  ~TransformableOutgoingAudioFrame() override = default;
   rtc::ArrayView<const uint8_t> GetData() const override { return payload_; }
   void SetData(rtc::ArrayView<const uint8_t> data) override {
     payload_.SetData(data.data(), data.size());
@@ -48,6 +48,7 @@
   int64_t GetAbsoluteCaptureTimestampMs() const {
     return absolute_capture_timestamp_ms_;
   }
+  Direction GetDirection() const override { return Direction::kSender; }
 
  private:
   AudioFrameType frame_type_;
@@ -90,9 +91,10 @@
     size_t payload_size,
     int64_t absolute_capture_timestamp_ms,
     uint32_t ssrc) {
-  frame_transformer_->Transform(std::make_unique<TransformableAudioFrame>(
-      frame_type, payload_type, rtp_timestamp, rtp_start_timestamp,
-      payload_data, payload_size, absolute_capture_timestamp_ms, ssrc));
+  frame_transformer_->Transform(
+      std::make_unique<TransformableOutgoingAudioFrame>(
+          frame_type, payload_type, rtp_timestamp, rtp_start_timestamp,
+          payload_data, payload_size, absolute_capture_timestamp_ms, ssrc));
 }
 
 void ChannelSendFrameTransformerDelegate::OnTransformedFrame(
@@ -111,9 +113,12 @@
     std::unique_ptr<TransformableFrameInterface> frame) const {
   MutexLock lock(&send_lock_);
   RTC_DCHECK_RUN_ON(encoder_queue_);
+  RTC_CHECK_EQ(frame->GetDirection(),
+               TransformableFrameInterface::Direction::kSender);
   if (!send_frame_callback_)
     return;
-  auto* transformed_frame = static_cast<TransformableAudioFrame*>(frame.get());
+  auto* transformed_frame =
+      static_cast<TransformableOutgoingAudioFrame*>(frame.get());
   send_frame_callback_(transformed_frame->GetFrameType(),
                        transformed_frame->GetPayloadType(),
                        transformed_frame->GetTimestamp() -
diff -Naur a/src/3rdparty/chromium/third_party/webrtc/modules/rtp_rtcp/source/rtp_sender_video_frame_transformer_delegate.cc b/src/3rdparty/chromium/third_party/webrtc/modules/rtp_rtcp/source/rtp_sender_video_frame_transformer_delegate.cc
--- a/src/3rdparty/chromium/third_party/webrtc/modules/rtp_rtcp/source/rtp_sender_video_frame_transformer_delegate.cc	2021-08-24 12:54:05.000000000 +0100
+++ b/src/3rdparty/chromium/third_party/webrtc/modules/rtp_rtcp/source/rtp_sender_video_frame_transformer_delegate.cc	2021-11-20 03:40:27.218660881 +0000
@@ -75,6 +75,8 @@
     return expected_retransmission_time_ms_;
   }
 
+  Direction GetDirection() const override { return Direction::kSender; }
+
  private:
   rtc::scoped_refptr<EncodedImageBufferInterface> encoded_data_;
   const RTPVideoHeader header_;
@@ -143,6 +145,8 @@
 void RTPSenderVideoFrameTransformerDelegate::SendVideo(
     std::unique_ptr<TransformableFrameInterface> transformed_frame) const {
   RTC_CHECK(encoder_queue_->IsCurrent());
+  RTC_CHECK_EQ(transformed_frame->GetDirection(),
+               TransformableFrameInterface::Direction::kSender);
   MutexLock lock(&sender_lock_);
   if (!sender_)
     return;
diff -Naur a/src/3rdparty/chromium/third_party/webrtc/video/rtp_video_stream_receiver_frame_transformer_delegate.cc b/src/3rdparty/chromium/third_party/webrtc/video/rtp_video_stream_receiver_frame_transformer_delegate.cc
--- a/src/3rdparty/chromium/third_party/webrtc/video/rtp_video_stream_receiver_frame_transformer_delegate.cc	2021-08-24 12:54:05.000000000 +0100
+++ b/src/3rdparty/chromium/third_party/webrtc/video/rtp_video_stream_receiver_frame_transformer_delegate.cc	2021-11-20 03:40:27.218660881 +0000
@@ -59,6 +59,8 @@
     return std::move(frame_);
   }
 
+  Direction GetDirection() const override { return Direction::kReceiver; }
+
  private:
   std::unique_ptr<video_coding::RtpFrameObject> frame_;
   const VideoFrameMetadata metadata_;
@@ -111,6 +113,8 @@
 void RtpVideoStreamReceiverFrameTransformerDelegate::ManageFrame(
     std::unique_ptr<TransformableFrameInterface> frame) {
   RTC_DCHECK_RUN_ON(&network_sequence_checker_);
+  RTC_CHECK_EQ(frame->GetDirection(),
+               TransformableFrameInterface::Direction::kReceiver);
   if (!receiver_)
     return;
   auto transformed_frame = absl::WrapUnique(
diff -Naur a/src/3rdparty/chromium/ui/webui/webui_allowlist.cc b/src/3rdparty/chromium/ui/webui/webui_allowlist.cc
--- a/src/3rdparty/chromium/ui/webui/webui_allowlist.cc	2021-08-24 12:54:05.000000000 +0100
+++ b/src/3rdparty/chromium/ui/webui/webui_allowlist.cc	2021-11-20 03:37:46.626204780 +0000
@@ -6,7 +6,11 @@
 
 #include <memory>
 
+#include "base/memory/scoped_refptr.h"
+#include "base/sequence_checker.h"
+#include "base/supports_user_data.h"
 #include "content/public/browser/browser_context.h"
+#include "content/public/browser/browser_thread.h"
 #include "content/public/common/url_constants.h"
 #include "ui/webui/webui_allowlist_provider.h"
 #include "url/gurl.h"
@@ -19,15 +23,27 @@
   using MapType = std::map<url::Origin, ContentSetting>;
 
  public:
-  explicit AllowlistRuleIterator(const MapType& map)
-      : it_(map.cbegin()), end_(map.cend()) {}
+  // Hold a reference to `allowlist` to keep it alive during iteration.
+  explicit AllowlistRuleIterator(scoped_refptr<const WebUIAllowlist> allowlist,
+                                 const MapType& map,
+                                 std::unique_ptr<base::AutoLock> auto_lock)
+      : auto_lock_(std::move(auto_lock)),
+        allowlist_(std::move(allowlist)),
+        it_(map.cbegin()),
+        end_(map.cend()) {}
   AllowlistRuleIterator(const AllowlistRuleIterator&) = delete;
   void operator=(const AllowlistRuleIterator&) = delete;
-  ~AllowlistRuleIterator() override = default;
+  ~AllowlistRuleIterator() override {
+    DCHECK_CALLED_ON_VALID_SEQUENCE(sequence_checker_);
+  }
 
-  bool HasNext() const override { return it_ != end_; }
+  bool HasNext() const override {
+    DCHECK_CALLED_ON_VALID_SEQUENCE(sequence_checker_);
+    return it_ != end_;
+  }
 
   content_settings::Rule Next() override {
+    DCHECK_CALLED_ON_VALID_SEQUENCE(sequence_checker_);
     const auto& origin = it_->first;
     const auto& setting = it_->second;
     it_++;
@@ -38,8 +54,18 @@
   }
 
  private:
-  MapType::const_iterator it_;
-  const MapType::const_iterator end_;
+  const std::unique_ptr<base::AutoLock> auto_lock_;
+  const scoped_refptr<const WebUIAllowlist> allowlist_;
+
+  SEQUENCE_CHECKER(sequence_checker_);
+  MapType::const_iterator it_ GUARDED_BY_CONTEXT(sequence_checker_);
+  MapType::const_iterator end_ GUARDED_BY_CONTEXT(sequence_checker_);
+};
+
+struct WebUIAllowlistHolder : base::SupportsUserData::Data {
+  explicit WebUIAllowlistHolder(scoped_refptr<WebUIAllowlist> list)
+      : allow_list(std::move(list)) {}
+  const scoped_refptr<WebUIAllowlist> allow_list;
 };
 
 }  // namespace
@@ -48,11 +74,14 @@
 WebUIAllowlist* WebUIAllowlist::GetOrCreate(
     content::BrowserContext* browser_context) {
   if (!browser_context->GetUserData(kWebUIAllowlistKeyName)) {
-    browser_context->SetUserData(kWebUIAllowlistKeyName,
-                                 std::make_unique<WebUIAllowlist>());
+    auto list = base::MakeRefCounted<WebUIAllowlist>();
+    browser_context->SetUserData(
+        kWebUIAllowlistKeyName,
+        std::make_unique<WebUIAllowlistHolder>(std::move(list)));
   }
-  return static_cast<WebUIAllowlist*>(
-      browser_context->GetUserData(kWebUIAllowlistKeyName));
+  return static_cast<WebUIAllowlistHolder*>(
+             browser_context->GetUserData(kWebUIAllowlistKeyName))
+      ->allow_list.get();
 }
 
 WebUIAllowlist::WebUIAllowlist() = default;
@@ -62,6 +91,9 @@
 void WebUIAllowlist::RegisterAutoGrantedPermission(const url::Origin& origin,
                                                    ContentSettingsType type,
                                                    ContentSetting setting) {
+  DCHECK_CURRENTLY_ON(content::BrowserThread::UI);
+  DCHECK_CALLED_ON_VALID_THREAD(thread_checker_);
+
   // It doesn't make sense to grant a default content setting.
   DCHECK_NE(CONTENT_SETTING_DEFAULT, setting);
 
@@ -70,13 +102,16 @@
   DCHECK(origin.scheme() == content::kChromeUIScheme ||
          origin.scheme() == content::kChromeUIUntrustedScheme ||
          origin.scheme() == content::kChromeDevToolsScheme);
+  {
+    base::AutoLock auto_lock(lock_);
 
-  // If the same permission is already registered, do nothing. We don't want to
-  // notify the provider of ContentSettingChange when it is unnecessary.
-  if (permissions_[type][origin] == setting)
-    return;
+    // If the same permission is already registered, do nothing. We don't want
+    // to notify the provider of ContentSettingChange when it is unnecessary.
+    if (permissions_[type][origin] == setting)
+      return;
 
-  permissions_[type][origin] = setting;
+    permissions_[type][origin] = setting;
+  }
 
   // Notify the provider. |provider_| can be nullptr if
   // HostContentSettingsRegistry is shutting down i.e. when Chrome shuts down.
@@ -92,25 +127,36 @@
 void WebUIAllowlist::RegisterAutoGrantedPermissions(
     const url::Origin& origin,
     std::initializer_list<ContentSettingsType> types) {
+  DCHECK_CURRENTLY_ON(content::BrowserThread::UI);
+  DCHECK_CALLED_ON_VALID_THREAD(thread_checker_);
+
   for (const ContentSettingsType& type : types)
     RegisterAutoGrantedPermission(origin, type);
 }
 
 void WebUIAllowlist::SetWebUIAllowlistProvider(
     WebUIAllowlistProvider* provider) {
+  DCHECK_CURRENTLY_ON(content::BrowserThread::UI);
+  DCHECK_CALLED_ON_VALID_THREAD(thread_checker_);
+
   provider_ = provider;
 }
 
 void WebUIAllowlist::ResetWebUIAllowlistProvider() {
+  DCHECK_CURRENTLY_ON(content::BrowserThread::UI);
+  DCHECK_CALLED_ON_VALID_THREAD(thread_checker_);
+
   provider_ = nullptr;
 }
 
 std::unique_ptr<content_settings::RuleIterator> WebUIAllowlist::GetRuleIterator(
     ContentSettingsType content_type) const {
-  const auto& type_to_origin_rules = permissions_.find(content_type);
-  if (type_to_origin_rules != permissions_.cend()) {
-    return std::make_unique<AllowlistRuleIterator>(
-        type_to_origin_rules->second);
+  auto auto_lock_ = std::make_unique<base::AutoLock>(lock_);
+
+  auto permissions_it = permissions_.find(content_type);
+  if (permissions_it != permissions_.end()) {
+    return std::make_unique<AllowlistRuleIterator>(this, permissions_it->second,
+                                                   std::move(auto_lock_));
   }
 
   return nullptr;
diff -Naur a/src/3rdparty/chromium/ui/webui/webui_allowlist.h b/src/3rdparty/chromium/ui/webui/webui_allowlist.h
--- a/src/3rdparty/chromium/ui/webui/webui_allowlist.h	2021-08-24 12:54:05.000000000 +0100
+++ b/src/3rdparty/chromium/ui/webui/webui_allowlist.h	2021-11-20 03:37:46.627204764 +0000
@@ -8,7 +8,9 @@
 #include <initializer_list>
 #include <map>
 
-#include "base/supports_user_data.h"
+#include "base/memory/ref_counted.h"
+#include "base/thread_annotations.h"
+#include "base/threading/thread_checker.h"
 #include "components/content_settings/core/browser/content_settings_rule.h"
 #include "components/content_settings/core/common/content_settings.h"
 #include "components/content_settings/core/common/content_settings_types.h"
@@ -23,14 +25,13 @@
 // list of origins and permissions to be auto-granted to WebUIs. This class is
 // created before HostContentSettingsMap is registered and has the same lifetime
 // as the profile it's attached to. It outlives WebUIAllowlistProvider.
-class WebUIAllowlist : public base::SupportsUserData::Data {
+class WebUIAllowlist : public base::RefCountedThreadSafe<WebUIAllowlist> {
  public:
   static WebUIAllowlist* GetOrCreate(content::BrowserContext* browser_context);
 
   WebUIAllowlist();
   WebUIAllowlist(const WebUIAllowlist&) = delete;
   void operator=(const WebUIAllowlist&) = delete;
-  ~WebUIAllowlist() override;
 
   // Register auto-granted |type| permission for |origin|.
   //
@@ -53,16 +54,29 @@
       const url::Origin& origin,
       std::initializer_list<ContentSettingsType> types);
 
+  // Returns a content_settings::RuleIterator, this method is thread-safe.
+  //
+  // This method acquires `lock_` and transfers it to the returned iterator.
+  // NO_THREAD_SAFETY_ANALYSIS because the analyzer doesn't recognize acquiring
+  // the lock in a unique_ptr.
   std::unique_ptr<content_settings::RuleIterator> GetRuleIterator(
-      ContentSettingsType content_type) const;
+      ContentSettingsType content_type) const NO_THREAD_SAFETY_ANALYSIS;
 
   void SetWebUIAllowlistProvider(WebUIAllowlistProvider* provider);
   void ResetWebUIAllowlistProvider();
 
  private:
+  friend class base::RefCountedThreadSafe<WebUIAllowlist>;
+  ~WebUIAllowlist();
+
+  THREAD_CHECKER(thread_checker_);
+
+  mutable base::Lock lock_;
   std::map<ContentSettingsType, std::map<url::Origin, ContentSetting>>
-      permissions_;
-  WebUIAllowlistProvider* provider_ = nullptr;
+      permissions_ GUARDED_BY(lock_);
+
+  WebUIAllowlistProvider* provider_ GUARDED_BY_CONTEXT(thread_checker_) =
+      nullptr;
 };
 
 #endif  // UI_WEBUI_WEBUI_ALLOWLIST_H_
diff -Naur a/src/3rdparty/chromium/ui/webui/webui_allowlist_provider.cc b/src/3rdparty/chromium/ui/webui/webui_allowlist_provider.cc
--- a/src/3rdparty/chromium/ui/webui/webui_allowlist_provider.cc	2021-08-24 12:54:05.000000000 +0100
+++ b/src/3rdparty/chromium/ui/webui/webui_allowlist_provider.cc	2021-11-20 03:37:46.627204764 +0000
@@ -7,8 +7,9 @@
 #include "components/content_settings/core/common/content_settings_pattern.h"
 #include "ui/webui/webui_allowlist.h"
 
-WebUIAllowlistProvider::WebUIAllowlistProvider(WebUIAllowlist* allowlist)
-    : allowlist_(allowlist) {
+WebUIAllowlistProvider::WebUIAllowlistProvider(
+    scoped_refptr<WebUIAllowlist> allowlist)
+    : allowlist_(std::move(allowlist)) {
   DCHECK(allowlist_);
   allowlist_->SetWebUIAllowlistProvider(this);
 }
@@ -20,8 +21,6 @@
     ContentSettingsType content_type,
     const content_settings::ResourceIdentifier& /*resource_identifier*/,
     bool incognito) const {
-  if (!allowlist_)
-    return nullptr;
 
   return allowlist_->GetRuleIterator(content_type);
 }
@@ -51,7 +50,7 @@
 }
 
 void WebUIAllowlistProvider::ShutdownOnUIThread() {
+  DCHECK(CalledOnValidThread());
   RemoveAllObservers();
   allowlist_->ResetWebUIAllowlistProvider();
-  allowlist_ = nullptr;
 }
diff -Naur a/src/3rdparty/chromium/ui/webui/webui_allowlist_provider.h b/src/3rdparty/chromium/ui/webui/webui_allowlist_provider.h
--- a/src/3rdparty/chromium/ui/webui/webui_allowlist_provider.h	2021-08-24 12:54:05.000000000 +0100
+++ b/src/3rdparty/chromium/ui/webui/webui_allowlist_provider.h	2021-11-20 03:37:46.627204764 +0000
@@ -5,6 +5,8 @@
 #ifndef UI_WEBUI_WEBUI_ALLOWLIST_PROVIDER_H_
 #define UI_WEBUI_WEBUI_ALLOWLIST_PROVIDER_H_
 
+#include "base/synchronization/lock.h"
+#include "base/thread_annotations.h"
 #include "components/content_settings/core/browser/content_settings_observable_provider.h"
 #include "components/content_settings/core/common/content_settings.h"
 #include "ui/webui/webui_allowlist.h"
@@ -15,8 +17,7 @@
 // permissions from the underlying WebUIAllowlist.
 class WebUIAllowlistProvider : public content_settings::ObservableProvider {
  public:
-  // Note, |allowlist| must outlive this instance.
-  explicit WebUIAllowlistProvider(WebUIAllowlist* allowlist);
+  explicit WebUIAllowlistProvider(scoped_refptr<WebUIAllowlist> allowlist);
   WebUIAllowlistProvider(const WebUIAllowlistProvider&) = delete;
   void operator=(const WebUIAllowlistProvider&) = delete;
   ~WebUIAllowlistProvider() override;
@@ -27,6 +28,7 @@
       ContentSettingsType content_type);
 
   // content_settings::ObservableProvider:
+  // The following methods are thread-safe.
   std::unique_ptr<content_settings::RuleIterator> GetRuleIterator(
       ContentSettingsType content_type,
       const content_settings::ResourceIdentifier& /*resource_identifier*/,
@@ -42,7 +44,7 @@
   void ClearAllContentSettingsRules(ContentSettingsType content_type) override;
 
  private:
-  WebUIAllowlist* allowlist_;
+  const scoped_refptr<WebUIAllowlist> allowlist_;
 };
 
 #endif  // UI_WEBUI_WEBUI_ALLOWLIST_PROVIDER_H_
diff -Naur a/src/3rdparty/chromium/v8/include/v8-version.h b/src/3rdparty/chromium/v8/include/v8-version.h
--- a/src/3rdparty/chromium/v8/include/v8-version.h	2021-08-24 12:54:05.000000000 +0100
+++ b/src/3rdparty/chromium/v8/include/v8-version.h	2021-11-20 03:42:17.697898746 +0000
@@ -11,7 +11,7 @@
 #define V8_MAJOR_VERSION 8
 #define V8_MINOR_VERSION 7
 #define V8_BUILD_NUMBER 220
-#define V8_PATCH_LEVEL 33
+#define V8_PATCH_LEVEL 34
 
 // Use 1 for candidates and 0 otherwise.
 // (Boolean macro values are not supported by all preprocessors.)
diff -Naur a/src/3rdparty/chromium/v8/src/heap/concurrent-marking.cc b/src/3rdparty/chromium/v8/src/heap/concurrent-marking.cc
--- a/src/3rdparty/chromium/v8/src/heap/concurrent-marking.cc	2021-08-24 12:54:05.000000000 +0100
+++ b/src/3rdparty/chromium/v8/src/heap/concurrent-marking.cc	2021-11-20 03:41:00.674124691 +0000
@@ -403,7 +403,7 @@
     isolate->PrintWithTimestamp("Starting concurrent marking task %d\n",
                                 task_id);
   }
-  bool ephemeron_marked = false;
+  bool another_ephemeron_iteration = false;
 
   {
     TimedScope scope(&time_ms);
@@ -413,7 +413,7 @@
 
       while (weak_objects_->current_ephemerons.Pop(task_id, &ephemeron)) {
         if (visitor.ProcessEphemeron(ephemeron.key, ephemeron.value)) {
-          ephemeron_marked = true;
+          another_ephemeron_iteration = true;
         }
       }
     }
@@ -454,6 +454,7 @@
           current_marked_bytes += visited_size;
         }
       }
+      if (objects_processed > 0) another_ephemeron_iteration = true;
       marked_bytes += current_marked_bytes;
       base::AsAtomicWord::Relaxed_Store<size_t>(&task_state->marked_bytes,
                                                 marked_bytes);
@@ -469,7 +470,7 @@
 
       while (weak_objects_->discovered_ephemerons.Pop(task_id, &ephemeron)) {
         if (visitor.ProcessEphemeron(ephemeron.key, ephemeron.value)) {
-          ephemeron_marked = true;
+          another_ephemeron_iteration = true;
         }
       }
     }
@@ -489,8 +490,8 @@
     base::AsAtomicWord::Relaxed_Store<size_t>(&task_state->marked_bytes, 0);
     total_marked_bytes_ += marked_bytes;
 
-    if (ephemeron_marked) {
-      set_ephemeron_marked(true);
+    if (another_ephemeron_iteration) {
+      set_another_ephemeron_iteration(true);
     }
 
     {
diff -Naur a/src/3rdparty/chromium/v8/src/heap/concurrent-marking.h b/src/3rdparty/chromium/v8/src/heap/concurrent-marking.h
--- a/src/3rdparty/chromium/v8/src/heap/concurrent-marking.h	2021-08-24 12:54:05.000000000 +0100
+++ b/src/3rdparty/chromium/v8/src/heap/concurrent-marking.h	2021-11-20 03:41:00.674124691 +0000
@@ -96,10 +96,12 @@
 
   size_t TotalMarkedBytes();
 
-  void set_ephemeron_marked(bool ephemeron_marked) {
-    ephemeron_marked_.store(ephemeron_marked);
+  void set_another_ephemeron_iteration(bool another_ephemeron_iteration) {
+    another_ephemeron_iteration_.store(another_ephemeron_iteration);
+  }
+  bool another_ephemeron_iteration() {
+    return another_ephemeron_iteration_.load();
   }
-  bool ephemeron_marked() { return ephemeron_marked_.load(); }
 
  private:
   struct TaskState {
@@ -121,7 +123,7 @@
   WeakObjects* const weak_objects_;
   TaskState task_state_[kMaxTasks + 1];
   std::atomic<size_t> total_marked_bytes_{0};
-  std::atomic<bool> ephemeron_marked_{false};
+  std::atomic<bool> another_ephemeron_iteration_{false};
   base::Mutex pending_lock_;
   base::ConditionVariable pending_condition_;
   int pending_task_count_ = 0;
diff -Naur a/src/3rdparty/chromium/v8/src/heap/incremental-marking.cc b/src/3rdparty/chromium/v8/src/heap/incremental-marking.cc
--- a/src/3rdparty/chromium/v8/src/heap/incremental-marking.cc	2021-08-24 12:54:05.000000000 +0100
+++ b/src/3rdparty/chromium/v8/src/heap/incremental-marking.cc	2021-11-20 03:41:00.674124691 +0000
@@ -1074,7 +1074,8 @@
     // This ignores that case where the embedder finds new V8-side objects. The
     // assumption is that large graphs are well connected and can mostly be
     // processed on their own. For small graphs, helping is not necessary.
-    v8_bytes_processed = collector_->ProcessMarkingWorklist(bytes_to_process);
+    std::tie(v8_bytes_processed, std::ignore) =
+        collector_->ProcessMarkingWorklist(bytes_to_process);
     StepResult v8_result = local_marking_worklists()->IsEmpty()
                                ? StepResult::kNoImmediateWork
                                : StepResult::kMoreWorkRemaining;
diff -Naur a/src/3rdparty/chromium/v8/src/heap/mark-compact.cc b/src/3rdparty/chromium/v8/src/heap/mark-compact.cc
--- a/src/3rdparty/chromium/v8/src/heap/mark-compact.cc	2021-08-24 12:54:05.000000000 +0100
+++ b/src/3rdparty/chromium/v8/src/heap/mark-compact.cc	2021-11-20 03:41:00.675124675 +0000
@@ -1641,24 +1641,24 @@
       descriptors, number_of_own_descriptors);
 }
 
-void MarkCompactCollector::ProcessEphemeronsUntilFixpoint() {
-  bool work_to_do = true;
+bool MarkCompactCollector::ProcessEphemeronsUntilFixpoint() {
   int iterations = 0;
   int max_iterations = FLAG_ephemeron_fixpoint_iterations;
 
-  while (work_to_do) {
+  bool another_ephemeron_iteration_main_thread;
+
+  do {
     PerformWrapperTracing();
 
     if (iterations >= max_iterations) {
       // Give up fixpoint iteration and switch to linear algorithm.
-      ProcessEphemeronsLinear();
-      break;
+      return false;
     }
 
     // Move ephemerons from next_ephemerons into current_ephemerons to
     // drain them in this iteration.
     weak_objects_.current_ephemerons.Swap(weak_objects_.next_ephemerons);
-    heap()->concurrent_marking()->set_ephemeron_marked(false);
+    heap()->concurrent_marking()->set_another_ephemeron_iteration(false);
 
     {
       TRACE_GC(heap()->tracer(),
@@ -1668,7 +1668,7 @@
         heap_->concurrent_marking()->RescheduleTasksIfNeeded();
       }
 
-      work_to_do = ProcessEphemerons();
+      another_ephemeron_iteration_main_thread = ProcessEphemerons();
       FinishConcurrentMarking(
           ConcurrentMarking::StopRequest::COMPLETE_ONGOING_TASKS);
     }
@@ -1676,40 +1676,47 @@
     CHECK(weak_objects_.current_ephemerons.IsEmpty());
     CHECK(weak_objects_.discovered_ephemerons.IsEmpty());
 
-    work_to_do = work_to_do || !local_marking_worklists()->IsEmpty() ||
-                 heap()->concurrent_marking()->ephemeron_marked() ||
-                 !local_marking_worklists()->IsEmbedderEmpty() ||
-                 !heap()->local_embedder_heap_tracer()->IsRemoteTracingDone();
     ++iterations;
-  }
+  } while (another_ephemeron_iteration_main_thread ||
+           heap()->concurrent_marking()->another_ephemeron_iteration() ||
+           !local_marking_worklists()->IsEmpty() ||
+           !local_marking_worklists()->IsEmbedderEmpty() ||
+           !heap()->local_embedder_heap_tracer()->IsRemoteTracingDone());
 
   CHECK(local_marking_worklists()->IsEmpty());
   CHECK(weak_objects_.current_ephemerons.IsEmpty());
   CHECK(weak_objects_.discovered_ephemerons.IsEmpty());
+  return true;
 }
 
 bool MarkCompactCollector::ProcessEphemerons() {
   Ephemeron ephemeron;
-  bool ephemeron_marked = false;
+  bool another_ephemeron_iteration = false;
 
   // Drain current_ephemerons and push ephemerons where key and value are still
   // unreachable into next_ephemerons.
   while (weak_objects_.current_ephemerons.Pop(kMainThreadTask, &ephemeron)) {
     if (ProcessEphemeron(ephemeron.key, ephemeron.value)) {
-      ephemeron_marked = true;
+      another_ephemeron_iteration = true;
     }
   }
 
   // Drain marking worklist and push discovered ephemerons into
   // discovered_ephemerons.
-  DrainMarkingWorklist();
+  size_t objects_processed;
+  std::tie(std::ignore, objects_processed) = ProcessMarkingWorklist(0);
+
+  // As soon as a single object was processed and potentially marked another
+  // object we need another iteration. Otherwise we might miss to apply
+  // ephemeron semantics on it.
+  if (objects_processed > 0) another_ephemeron_iteration = true;
 
   // Drain discovered_ephemerons (filled in the drain MarkingWorklist-phase
   // before) and push ephemerons where key and value are still unreachable into
   // next_ephemerons.
   while (weak_objects_.discovered_ephemerons.Pop(kMainThreadTask, &ephemeron)) {
     if (ProcessEphemeron(ephemeron.key, ephemeron.value)) {
-      ephemeron_marked = true;
+      another_ephemeron_iteration = true;
     }
   }
 
@@ -1717,7 +1724,7 @@
   weak_objects_.ephemeron_hash_tables.FlushToGlobal(kMainThreadTask);
   weak_objects_.next_ephemerons.FlushToGlobal(kMainThreadTask);
 
-  return ephemeron_marked;
+  return another_ephemeron_iteration;
 }
 
 void MarkCompactCollector::ProcessEphemeronsLinear() {
@@ -1803,6 +1810,12 @@
   ephemeron_marking_.newly_discovered.shrink_to_fit();
 
   CHECK(local_marking_worklists()->IsEmpty());
+  CHECK(weak_objects_.current_ephemerons.IsEmpty());
+  CHECK(weak_objects_.discovered_ephemerons.IsEmpty());
+
+  // Flush local ephemerons for main task to global pool.
+  weak_objects_.ephemeron_hash_tables.FlushToGlobal(kMainThreadTask);
+  weak_objects_.next_ephemerons.FlushToGlobal(kMainThreadTask);
 }
 
 void MarkCompactCollector::PerformWrapperTracing() {
@@ -1824,9 +1837,11 @@
 void MarkCompactCollector::DrainMarkingWorklist() { ProcessMarkingWorklist(0); }
 
 template <MarkCompactCollector::MarkingWorklistProcessingMode mode>
-size_t MarkCompactCollector::ProcessMarkingWorklist(size_t bytes_to_process) {
+std::pair<size_t, size_t> MarkCompactCollector::ProcessMarkingWorklist(
+    size_t bytes_to_process) {
   HeapObject object;
   size_t bytes_processed = 0;
+  size_t objects_processed = 0;
   bool is_per_context_mode = local_marking_worklists()->IsPerContextMode();
   Isolate* isolate = heap()->isolate();
   while (local_marking_worklists()->Pop(&object) ||
@@ -1866,18 +1881,19 @@
                                           map, object, visited_size);
     }
     bytes_processed += visited_size;
+    objects_processed++;
     if (bytes_to_process && bytes_processed >= bytes_to_process) {
       break;
     }
   }
-  return bytes_processed;
+  return std::make_pair(bytes_processed, objects_processed);
 }
 
 // Generate definitions for use in other files.
-template size_t MarkCompactCollector::ProcessMarkingWorklist<
+template std::pair<size_t, size_t> MarkCompactCollector::ProcessMarkingWorklist<
     MarkCompactCollector::MarkingWorklistProcessingMode::kDefault>(
     size_t bytes_to_process);
-template size_t MarkCompactCollector::ProcessMarkingWorklist<
+template std::pair<size_t, size_t> MarkCompactCollector::ProcessMarkingWorklist<
     MarkCompactCollector::MarkingWorklistProcessingMode::
         kTrackNewlyDiscoveredObjects>(size_t bytes_to_process);
 
@@ -1902,7 +1918,23 @@
   // buffer, flush it into global pool.
   weak_objects_.next_ephemerons.FlushToGlobal(kMainThreadTask);
 
-  ProcessEphemeronsUntilFixpoint();
+  if (!ProcessEphemeronsUntilFixpoint()) {
+    // Fixpoint iteration needed too many iterations and was cancelled. Use the
+    // guaranteed linear algorithm.
+    ProcessEphemeronsLinear();
+  }
+
+#ifdef VERIFY_HEAP
+  if (FLAG_verify_heap) {
+    Ephemeron ephemeron;
+
+    weak_objects_.current_ephemerons.Swap(weak_objects_.next_ephemerons);
+
+    while (weak_objects_.current_ephemerons.Pop(kMainThreadTask, &ephemeron)) {
+      CHECK(!ProcessEphemeron(ephemeron.key, ephemeron.value));
+    }
+  }
+#endif
 
   CHECK(local_marking_worklists()->IsEmpty());
   CHECK(heap()->local_embedder_heap_tracer()->IsRemoteTracingDone());
diff -Naur a/src/3rdparty/chromium/v8/src/heap/mark-compact.h b/src/3rdparty/chromium/v8/src/heap/mark-compact.h
--- a/src/3rdparty/chromium/v8/src/heap/mark-compact.h	2021-08-24 12:54:05.000000000 +0100
+++ b/src/3rdparty/chromium/v8/src/heap/mark-compact.h	2021-11-20 03:41:00.675124675 +0000
@@ -590,7 +590,7 @@
   // is drained until it is empty.
   template <MarkingWorklistProcessingMode mode =
                 MarkingWorklistProcessingMode::kDefault>
-  size_t ProcessMarkingWorklist(size_t bytes_to_process);
+  std::pair<size_t, size_t> ProcessMarkingWorklist(size_t bytes_to_process);
 
  private:
   void ComputeEvacuationHeuristics(size_t area_size,
@@ -636,8 +636,9 @@
   bool ProcessEphemeron(HeapObject key, HeapObject value);
 
   // Marks ephemerons and drains marking worklist iteratively
-  // until a fixpoint is reached.
-  void ProcessEphemeronsUntilFixpoint();
+  // until a fixpoint is reached. Returns false if too many iterations have been
+  // tried and the linear approach should be used.
+  bool ProcessEphemeronsUntilFixpoint();
 
   // Drains ephemeron and marking worklists. Single iteration of the
   // fixpoint iteration.
diff -Naur a/src/3rdparty/chromium/v8/src/objects/js-function.cc b/src/3rdparty/chromium/v8/src/objects/js-function.cc
--- a/src/3rdparty/chromium/v8/src/objects/js-function.cc	2021-08-24 12:54:05.000000000 +0100
+++ b/src/3rdparty/chromium/v8/src/objects/js-function.cc	2021-11-20 03:35:29.683326507 +0000
@@ -291,6 +291,14 @@
 void JSFunction::InitializeFeedbackCell(Handle<JSFunction> function,
                                         IsCompiledScope* is_compiled_scope) {
   Isolate* const isolate = function->GetIsolate();
+#if V8_ENABLE_WEBASSEMBLY
+  // The following checks ensure that the feedback vectors are compatible with
+  // the feedback metadata. For Asm / Wasm functions we never allocate / use
+  // feedback vectors, so a mismatch between the metadata and feedback vector is
+  // harmless. The checks could fail for functions that has has_asm_wasm_broken
+  // set at runtime (for ex: failed instantiation).
+  if (function->shared().HasAsmWasmData()) return;
+#endif  // V8_ENABLE_WEBASSEMBLY
 
   if (function->has_feedback_vector()) {
     CHECK_EQ(function->feedback_vector().length(),
